
%validation for 1D henon implicit fixed point

clear
format long

alpha = 1.4;
beta  = 0.3;
epsi  = 0.001;
N     = 20;        %Polynomial approximation order
scale = 1;
scale1 = 0.5;

%  x0 = [-3;3];
p3=[1;2];
p_3= Newton_for_Henon_fixed_point(p3,alpha,beta,epsi);
 
p2 = [-3;3];
p_f1 = Newton_for_Henon_fixed_point(p2,alpha,beta,epsi);
%Fixed Point of Henon Imp
x0 =[1;1];
p0 = Newton_for_Henon_fixed_point(x0,alpha,beta,epsi);
 
 figure
 hold on
 plot(p_f1(1),p_f1(2),'r*')
 plot(p0(1),p0(2),'k*')
 plot(p_3(1),p_3(2),'g*')
 hold off
%  return
%Eigenvalues and Eigen Vectors
[R,Sigma] = eigs(Diff_for_Eigen(p0,alpha,beta, epsi));


% For manofold nearby fixed point
 P = zeros(2,N+1);
 Q = zeros(2,N+1);
 Lambda = Sigma(1,1);
 Tambda = Sigma(2,2);
 mu = Lambda^(-1);
 nu=Tambda^(-1);
 P(:,1) = p0;
 P(:,2) = scale1*R(:,1);
 Q(:,1) =p0;
 Q(:,2)=scale*R(:,2);
 P;
 Q ;
 

 [P,Q]=fixed_cauchy(P,Q,p0,mu,nu,alpha,beta,epsi,N); 

P;
Q;

numPoints = 20000;
NumR =500;
radii = abs(mu);
Thetas = linspace(-1,1, numPoints);
Thetas1 = linspace(radii,1,NumR);
% Thetas2
Wu1 = [real(polyval(fliplr(P(1, :)), Thetas));
                   real(polyval(fliplr(P(2, :)), Thetas))];
               
Wu2 = [real(polyval(fliplr(Q(1, :)), Thetas));
                   real(polyval(fliplr(Q(2, :)), Thetas))];
               
Wuc =  [real(polyval(fliplr(P(1, :)), Thetas1));
                   real(polyval(fliplr(P(2, :)), Thetas1))];              
Wsc = [real(polyval(fliplr(Q(1, :)), Thetas1));
                   real(polyval(fliplr(Q(2, :)), Thetas1))];                 
               


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 S = Wuc;
 S1= Wsc;
 K=4;
 iterates_S=zeros(2,NumR,K);
 iterates_S1=zeros(2,NumR,K);
 iterates_S(:,:,1)= S;
 iterates_S1(:,:,1)= S1;
 
 for j=2:K
    for i=1:NumR
       u0=iterates_S(:,i,j-1); %unstable 
       v0=iterates_S1(:,i,j-1); %stable
       y =for_function(u0,alpha,beta);
%        x =back_function(v0,alpha,beta);
       iterates_S(:,i,j)=Newton_for_orbit(y,u0,alpha,beta,epsi);
%        iterates_S1(:,i,j)=Newton_back_function(x,v0,alpha,beta,epsi);
    end
 end   
iterates_S;
iterates_S1;

figure
hold on
  plot(Wu1(1,:), Wu1(2,:), 'b','LineWidth',2)
  plot(Wu2(1,:), Wu2(2,:), 'r','LineWidth',2) 
   plot(Wuc(1,:), Wuc(2,:), '*')
   plot(Wsc(1,:), Wsc(2,:), 'k') 
  plot(p0(1),p0(2),'k*')
  title('Stable and unstable 1D manifold of a fixed point')
  %legend('unstable manifold','stable manifold','FontSize',8),
  
 
  for i=2:K
     plot(iterates_S(1,:,i),iterates_S(2,:,i),'b','LineWidth',2)
%      plot(iterates_S1(1,:,i),iterates_S1(2,:,i),'k')
  end
%   return
  
K1=iterates_S(:,:,K);
K2=Wsc;
d=norm(K1(:,1)-K2(:,1));
i=1; %ith position for unstable
j=1; %jth position for stable
for m=1:NumR
    for n=1:NumR
        d1=norm(K1(:,m)-K2(:,n));
        if d1<d
            d=d1;
            i=m;
            j=n;
        else 
        end
    end
end
d;
i;
j;
P_theta=Wuc(:,i);
x1=P_theta;
x2=iterates_S(:,i,2);
x3=iterates_S(:,i,3);
x4=iterates_S(:,i,4);
Q_sigma=Wsc(:,j);
P_gamma=K1(:,i);
theta=Thetas1(i);
sigma= Thetas1(j);
P_theta_test=[real(polyval(fliplr(P(1, :)), theta));
                   real(polyval(fliplr(P(2, :)), theta))];
Q_sigma_test=[real(polyval(fliplr(Q(1, :)), sigma));
                   real(polyval(fliplr(Q(2, :)), sigma))];               
 
 
 
%   plot(P_theta_test(1,1),P_theta_test(2,1),'b*')
%   plot(Q_sigma_test(1,1),Q_sigma_test(2,1),'m*')

    x0=[theta; x1; x2; x3; x4; sigma];
 
   p = Newton_for_connection(N,P,Q,theta,x1,x2,x3,x4,sigma,alpha,beta,epsi,K);   


 plot(p(2,:),p(3,:),'k*') 
 plot(p(4,:),p(5,:),'k*') 
 plot(p(6,:),p(7,:),'k*') 
 plot(p(8,:),p(9,:),'k*') 
hold off


               